#include "Stage.h"
#include "Stages.h"

static const byte[] Stairs00 = {
	(9 << 4) | 3,
	(4 << 4) | 6,
};

static const byte[] Monsters00 = {
	(5 << 4) | 1, 0x02,
	(9 << 4) | 1, 0x01,
	(5 << 4) | 5, 0x02,
	(8 << 4) | 5, 0x01,
};

static const byte[] Knives00 = {
	(3 << 4) | 0,
	(2 << 4) | 6,
};

static const byte[] Monsters01 = {
	(6 << 4) | 2, 0x00,
	(6 << 4) | 4, 0x02,
};

static const byte[] Knives01 = {
	(9 << 4) | 1,
	(1 << 4) | 4,
};

static const Floor[] Floors0 = {
	{
		{
			0xc6, 0x88, 0x06, 
			0x6c, 0x1e, 0x05, 
			0x81, 0x71, 0x05, 
			0x65, 0xce, 0x0d, 
			0xce, 0x38, 0x07, 
			0x38, 0xe3, 0x0c, 
			0xba, 0xab, 0x0e, 
		},
		2, Stairs00,
		4, Monsters00,
		2, Knives00,
	},
	{
		{
			0x44, 0x88, 0x04, 
			0xdd, 0x1e, 0x0d, 
			0x15, 0x72, 0x06, 
			0x5a, 0xcd, 0x05, 
			0xc5, 0x34, 0x07, 
			0x1c, 0x53, 0x0c, 
			0xaa, 0xef, 0x0e, 
		},
		0, nullptr,
		2, Monsters01,
		2, Knives01,
	},
};
static const byte[] Stairs10 = {
	(9 << 4) | 0,
	(2 << 4) | 2,
	(0 << 4) | 3,
	(9 << 4) | 5,
	(0 << 4) | 6,
	(5 << 4) | 6,
};

static const byte[] Monsters10 = {
	(0 << 4) | 0, 0x01,
	(7 << 4) | 0, 0x00,
	(7 << 4) | 3, 0x02,
};

static const byte[] Knives10 = {
	(7 << 4) | 1,
	(6 << 4) | 6,
};

static const byte[] Monsters11 = {
	(3 << 4) | 2, 0x02,
	(4 << 4) | 2, 0x02,
};

static const Floor[] Floors1 = {
	{
		{
			0xa8, 0x11, 0x05, 
			0x11, 0xd7, 0x0e, 
			0xbd, 0x65, 0x04, 
			0x1a, 0x9b, 0x07, 
			0x7c, 0x38, 0x05, 
			0xc6, 0xea, 0x0d, 
			0xae, 0xae, 0x0e, 
		},
		6, Stairs10,
		3, Monsters10,
		2, Knives10,
	},
	{
		{
			0xa8, 0x21, 0x05, 
			0x22, 0x57, 0x05, 
			0x96, 0x7a, 0x04, 
			0x19, 0x65, 0x0f, 
			0xd4, 0x28, 0x06, 
			0x4d, 0xda, 0x05, 
			0xbe, 0xee, 0x0e, 
		},
		0, nullptr,
		2, Monsters11,
		0, nullptr,
	},
};
static const byte[] Stairs20 = {
	(4 << 4) | 0,
	(7 << 4) | 6,
};

static const byte[] Monsters20 = {
	(3 << 4) | 1, 0x01,
	(5 << 4) | 1, 0x01,
	(7 << 4) | 2, 0x02,
	(5 << 4) | 6, 0x01,
};

static const byte[] Knives20 = {
	(4 << 4) | 6,
};

static const byte[] Stairs21 = {
	(8 << 4) | 1,
	(2 << 4) | 4,
	(6 << 4) | 6,
	(9 << 4) | 6,
};

static const byte[] Monsters21 = {
	(6 << 4) | 1, 0x02,
	(7 << 4) | 3, 0x02,
	(4 << 4) | 6, 0x02,
};

static const byte[] Knives21 = {
	(8 << 4) | 2,
};

static const byte[] Monsters22 = {
	(4 << 4) | 2, 0x01,
	(9 << 4) | 2, 0x02,
	(7 << 4) | 4, 0x02,
	(1 << 4) | 6, 0x02,
};

static const byte[] Knives22 = {
	(8 << 4) | 6,
};

static const Floor[] Floors2 = {
	{
		{
			0x68, 0x86, 0x05, 
			0xc6, 0x1e, 0x07, 
			0xac, 0xb1, 0x06, 
			0x62, 0x8e, 0x06, 
			0xec, 0x38, 0x05, 
			0x6a, 0xc6, 0x0d, 
			0xaa, 0xbb, 0x0e, 
		},
		2, Stairs20,
		4, Monsters20,
		1, Knives20,
	},
	{
		{
			0x24, 0x83, 0x06, 
			0xe9, 0x15, 0x0f, 
			0x9c, 0x72, 0x06, 
			0x45, 0x8e, 0x05, 
			0xdc, 0x38, 0x06, 
			0x96, 0xc6, 0x0e, 
			0xaa, 0xbb, 0x0e, 
		},
		4, Stairs21,
		3, Monsters21,
		1, Knives21,
	},
	{
		{
			0x68, 0x48, 0x06, 
			0xc6, 0x1e, 0x07, 
			0xac, 0xb1, 0x06, 
			0x46, 0x4e, 0x0e, 
			0x7c, 0xb8, 0x06, 
			0x56, 0xc6, 0x06, 
			0xaa, 0xab, 0x0f, 
		},
		0, nullptr,
		4, Monsters22,
		1, Knives22,
	},
};
static const byte[] Stairs30 = {
	(9 << 4) | 1,
	(6 << 4) | 3,
	(9 << 4) | 3,
	(4 << 4) | 6,
	(7 << 4) | 6,
};

static const byte[] Monsters30 = {
	(4 << 4) | 3, 0x01,
	(7 << 4) | 3, 0x02,
};

static const byte[] Knives30 = {
	(5 << 4) | 6,
	(9 << 4) | 6,
};

static const byte[] Stairs31 = {
	(0 << 4) | 0,
	(4 << 4) | 0,
	(7 << 4) | 0,
	(5 << 4) | 2,
	(4 << 4) | 4,
	(0 << 4) | 5,
	(5 << 4) | 5,
	(8 << 4) | 6,
};

static const byte[] Monsters31 = {
	(0 << 4) | 1, 0x02,
	(1 << 4) | 1, 0x02,
	(2 << 4) | 1, 0x02,
};

static const byte[] Monsters32 = {
	(5 << 4) | 3, 0x00,
};

static const byte[] Knives32 = {
	(9 << 4) | 3,
};

static const Floor[] Floors3 = {
	{
		{
			0x84, 0x6a, 0x0c, 
			0xa5, 0x51, 0x0e, 
			0x69, 0x5e, 0x04, 
			0xe1, 0x94, 0x0f, 
			0x69, 0x39, 0x06, 
			0xc6, 0x5a, 0x05, 
			0xae, 0xbb, 0x0f, 
		},
		5, Stairs30,
		2, Monsters30,
		2, Knives30,
	},
	{
		{
			0xaa, 0xa7, 0x06, 
			0x55, 0xa1, 0x0d, 
			0xa8, 0x5d, 0x04, 
			0xe1, 0x5a, 0x0f, 
			0x6a, 0x3a, 0x06, 
			0xc9, 0x59, 0x04, 
			0xea, 0xfa, 0x0f, 
		},
		8, Stairs31,
		3, Monsters31,
		0, nullptr,
	},
	{
		{
			0xc5, 0xea, 0x0c, 
			0x65, 0x51, 0x06, 
			0x65, 0x6e, 0x04, 
			0xd1, 0x94, 0x0f, 
			0x9d, 0x29, 0x0e, 
			0xc9, 0xa9, 0x04, 
			0xee, 0xab, 0x0f, 
		},
		0, nullptr,
		1, Monsters32,
		1, Knives32,
	},
};
static const byte[] Stairs40 = {
	(9 << 4) | 3,
	(0 << 4) | 5,
};

static const byte[] Monsters40 = {
	(8 << 4) | 0, 0x01,
	(5 << 4) | 2, 0x02,
	(5 << 4) | 6, 0x02,
	(6 << 4) | 6, 0x02,
	(7 << 4) | 6, 0x02,
	(8 << 4) | 6, 0x02,
};

static const byte[] Knives40 = {
	(7 << 4) | 3,
};

static const byte[] Stairs41 = {
	(9 << 4) | 1,
	(1 << 4) | 6,
};

static const byte[] Monsters41 = {
	(8 << 4) | 5, 0x02,
};

static const byte[] Knives41 = {
	(8 << 4) | 2,
};

static const byte[] Stairs42 = {
	(1 << 4) | 5,
	(8 << 4) | 6,
};

static const byte[] Monsters42 = {
	(3 << 4) | 3, 0x02,
	(5 << 4) | 6, 0x01,
};

static const byte[] Knives42 = {
	(8 << 4) | 3,
};

static const byte[] Monsters43 = {
	(4 << 4) | 0, 0x01,
	(3 << 4) | 3, 0x02,
};

static const byte[] Knives43 = {
	(9 << 4) | 3,
};

static const Floor[] Floors4 = {
	{
		{
			0x46, 0xa8, 0x04, 
			0x5c, 0x86, 0x07, 
			0xb8, 0xae, 0x05, 
			0x1a, 0x5a, 0x0f, 
			0xe4, 0xe4, 0x04, 
			0x85, 0x87, 0x0f, 
			0xba, 0xaa, 0x0e, 
		},
		2, Stairs40,
		6, Monsters40,
		1, Knives40,
	},
	{
		{
			0x88, 0x84, 0x06, 
			0x6c, 0x86, 0x07, 
			0x66, 0x5d, 0x05, 
			0x26, 0x29, 0x07, 
			0xda, 0xd4, 0x04, 
			0x86, 0x5b, 0x0f, 
			0xbe, 0xab, 0x0e, 
		},
		2, Stairs41,
		1, Monsters41,
		1, Knives41,
	},
	{
		{
			0x44, 0xa8, 0x06, 
			0x5d, 0x61, 0x0e, 
			0xb4, 0xad, 0x06, 
			0x29, 0x19, 0x07, 
			0xda, 0xe8, 0x04, 
			0x8c, 0x87, 0x07, 
			0xae, 0xea, 0x0e, 
		},
		2, Stairs42,
		2, Monsters42,
		1, Knives42,
	},
	{
		{
			0x88, 0x68, 0x06, 
			0x6e, 0x85, 0x07, 
			0x78, 0xae, 0x04, 
			0x25, 0x1a, 0x0f, 
			0xd8, 0xd8, 0x04, 
			0x85, 0x8b, 0x07, 
			0xae, 0xea, 0x0e, 
		},
		0, nullptr,
		2, Monsters43,
		1, Knives43,
	},
};
static const byte[] Stairs50 = {
	(9 << 4) | 0,
	(8 << 4) | 1,
	(1 << 4) | 4,
	(3 << 4) | 6,
	(9 << 4) | 6,
};

static const byte[] Monsters50 = {
	(7 << 4) | 3, 0x01,
	(0 << 4) | 4, 0x02,
	(0 << 4) | 5, 0x02,
	(7 << 4) | 5, 0x02,
	(0 << 4) | 6, 0x02,
	(1 << 4) | 6, 0x02,
};

static const byte[] Knives50 = {
	(3 << 4) | 5,
};

static const byte[] Stairs51 = {
	(9 << 4) | 1,
	(0 << 4) | 3,
	(3 << 4) | 3,
	(6 << 4) | 3,
	(2 << 4) | 4,
	(3 << 4) | 5,
};

static const byte[] Monsters51 = {
	(1 << 4) | 1, 0x02,
	(2 << 4) | 1, 0x01,
	(1 << 4) | 3, 0x02,
	(7 << 4) | 5, 0x00,
};

static const byte[] Knives51 = {
	(0 << 4) | 5,
};

static const byte[] Stairs52 = {
	(5 << 4) | 0,
	(9 << 4) | 0,
	(9 << 4) | 3,
	(9 << 4) | 6,
};

static const byte[] Monsters52 = {
	(2 << 4) | 3, 0x02,
	(6 << 4) | 5, 0x00,
	(5 << 4) | 6, 0x01,
};

static const byte[] Knives52 = {
	(4 << 4) | 1,
};

static const byte[] Monsters53 = {
	(7 << 4) | 2, 0x02,
	(1 << 4) | 3, 0x02,
	(5 << 4) | 6, 0x02,
};

static const byte[] Knives53 = {
	(6 << 4) | 2,
};

static const Floor[] Floors5 = {
	{
		{
			0x84, 0x11, 0x06, 
			0x15, 0x5f, 0x0d, 
			0x55, 0x58, 0x05, 
			0x95, 0xb3, 0x0f, 
			0x1d, 0xa9, 0x06, 
			0xd5, 0x55, 0x0d, 
			0xee, 0xaa, 0x0e, 
		},
		5, Stairs50,
		6, Monsters50,
		1, Knives50,
	},
	{
		{
			0x84, 0x22, 0x05, 
			0x39, 0xef, 0x0f, 
			0x96, 0x28, 0x06, 
			0xa9, 0xb3, 0x0f, 
			0xae, 0x59, 0x05, 
			0x98, 0x23, 0x0e, 
			0xaa, 0xae, 0x0e, 
		},
		6, Stairs51,
		4, Monsters51,
		1, Knives51,
	},
	{
		{
			0x84, 0x21, 0x05, 
			0x79, 0x7b, 0x0f, 
			0xaa, 0x24, 0x06, 
			0x78, 0x73, 0x0f, 
			0xec, 0xd5, 0x04, 
			0x1c, 0x23, 0x0f, 
			0xea, 0xba, 0x0e, 
		},
		4, Stairs52,
		3, Monsters52,
		1, Knives52,
	},
	{
		{
			0x88, 0x2c, 0x0e, 
			0x36, 0xbb, 0x05, 
			0x56, 0x14, 0x06, 
			0x98, 0xbb, 0x0f, 
			0x1e, 0x55, 0x06, 
			0x58, 0x13, 0x05, 
			0xaa, 0xee, 0x0e, 
		},
		0, nullptr,
		3, Monsters53,
		1, Knives53,
	},
};
static const byte[] Stairs60 = {
	(1 << 4) | 1,
	(3 << 4) | 1,
	(5 << 4) | 1,
	(7 << 4) | 1,
	(9 << 4) | 1,
	(1 << 4) | 2,
};

static const byte[] Monsters60 = {
	(5 << 4) | 5, 0x02,
	(6 << 4) | 5, 0x02,
	(4 << 4) | 6, 0x02,
	(7 << 4) | 6, 0x02,
};

static const byte[] Stairs61 = {
	(0 << 4) | 0,
	(3 << 4) | 2,
	(5 << 4) | 2,
	(7 << 4) | 2,
	(9 << 4) | 2,
	(3 << 4) | 4,
	(5 << 4) | 4,
	(7 << 4) | 4,
	(9 << 4) | 4,
	(3 << 4) | 6,
	(5 << 4) | 6,
	(7 << 4) | 6,
	(9 << 4) | 6,
};

static const byte[] Monsters61 = {
	(1 << 4) | 3, 0x02,
};

static const byte[] Knives61 = {
	(9 << 4) | 0,
};

static const byte[] Stairs62 = {
	(9 << 4) | 0,
	(3 << 4) | 1,
	(7 << 4) | 1,
	(9 << 4) | 1,
	(3 << 4) | 3,
	(5 << 4) | 3,
	(9 << 4) | 3,
	(5 << 4) | 5,
	(7 << 4) | 5,
	(9 << 4) | 5,
};

static const byte[] Monsters62 = {
	(0 << 4) | 1, 0x02,
};

static const byte[] Knives62 = {
	(7 << 4) | 3,
};

static const byte[] Stairs63 = {
	(3 << 4) | 2,
	(5 << 4) | 2,
	(9 << 4) | 2,
	(7 << 4) | 4,
	(9 << 4) | 4,
	(1 << 4) | 6,
	(5 << 4) | 6,
};

static const byte[] Monsters63 = {
	(1 << 4) | 0, 0x02,
	(4 << 4) | 1, 0x02,
	(6 << 4) | 3, 0x02,
	(1 << 4) | 4, 0x02,
};

static const byte[] Knives63 = {
	(9 << 4) | 6,
};

static const byte[] Monsters64 = {
	(4 << 4) | 0, 0x00,
};

static const byte[] Knives64 = {
	(8 << 4) | 6,
};

static const Floor[] Floors6 = {
	{
		{
			0x22, 0x22, 0x06, 
			0xdd, 0xdd, 0x0d, 
			0x1a, 0x4e, 0x04, 
			0x78, 0x50, 0x0d, 
			0x98, 0x55, 0x06, 
			0xa6, 0x7d, 0x04, 
			0xae, 0xae, 0x0f, 
		},
		6, Stairs60,
		4, Monsters60,
		0, nullptr,
	},
	{
		{
			0x11, 0x11, 0x0e, 
			0xdd, 0xdd, 0x0c, 
			0xc5, 0xcc, 0x0c, 
			0xc5, 0xcc, 0x0c, 
			0xc5, 0xcc, 0x0c, 
			0xc5, 0xcc, 0x0c, 
			0xee, 0xee, 0x0e, 
		},
		13, Stairs61,
		1, Monsters61,
		1, Knives61,
	},
	{
		{
			0xa1, 0xaa, 0x0e, 
			0xc5, 0xcc, 0x0c, 
			0xe5, 0xee, 0x0e, 
			0xc5, 0xcc, 0x0c, 
			0xe5, 0xee, 0x0e, 
			0xc5, 0xcc, 0x0c, 
			0xee, 0xee, 0x0e, 
		},
		10, Stairs62,
		1, Monsters62,
		1, Knives62,
	},
	{
		{
			0xa8, 0xaa, 0x0e, 
			0xc6, 0xc4, 0x0c, 
			0xec, 0xed, 0x0e, 
			0xc6, 0x45, 0x0c, 
			0xec, 0xde, 0x0e, 
			0x6a, 0x5c, 0x0c, 
			0xea, 0xee, 0x0e, 
		},
		7, Stairs63,
		4, Monsters63,
		1, Knives63,
	},
	{
		{
			0xa8, 0x2a, 0x0e, 
			0xc6, 0x5c, 0x0c, 
			0xec, 0x6e, 0x0e, 
			0x6a, 0xcc, 0x0c, 
			0x64, 0xef, 0x0c, 
			0x59, 0x58, 0x06, 
			0xee, 0xae, 0x0f, 
		},
		0, nullptr,
		1, Monsters64,
		1, Knives64,
	},
};
static const byte[] Stairs70 = {
	(9 << 4) | 1,
	(5 << 4) | 6,
};

static const byte[] Monsters70 = {
	(9 << 4) | 0, 0x01,
	(8 << 4) | 5, 0x02,
};

static const byte[] Knives70 = {
	(7 << 4) | 6,
};

static const byte[] Stairs71 = {
	(9 << 4) | 3,
	(0 << 4) | 6,
};

static const byte[] Monsters71 = {
	(4 << 4) | 0, 0x02,
	(6 << 4) | 2, 0x02,
	(3 << 4) | 3, 0x02,
};

static const byte[] Stairs72 = {
	(0 << 4) | 2,
	(6 << 4) | 6,
};

static const byte[] Monsters72 = {
	(1 << 4) | 1, 0x02,
	(6 << 4) | 2, 0x00,
	(2 << 4) | 4, 0x02,
	(9 << 4) | 6, 0x00,
};

static const byte[] Knives72 = {
	(8 << 4) | 1,
	(7 << 4) | 5,
};

static const byte[] Stairs73 = {
	(8 << 4) | 2,
	(2 << 4) | 6,
	(9 << 4) | 6,
};

static const byte[] Monsters73 = {
	(5 << 4) | 2, 0x02,
	(1 << 4) | 4, 0x02,
	(7 << 4) | 5, 0x02,
};

static const byte[] Monsters74 = {
	(7 << 4) | 1, 0x02,
	(3 << 4) | 4, 0x02,
	(2 << 4) | 5, 0x02,
	(9 << 4) | 5, 0x02,
};

static const byte[] Knives74 = {
	(4 << 4) | 3,
};

static const Floor[] Floors7 = {
	{
		{
			0x68, 0x84, 0x06, 
			0x11, 0xa5, 0x0d, 
			0x5e, 0x29, 0x07, 
			0xb8, 0x13, 0x0e, 
			0x1a, 0x5e, 0x04, 
			0xb8, 0x96, 0x07, 
			0xaa, 0xbf, 0x0e, 
		},
		2, Stairs70,
		2, Monsters70,
		1, Knives70,
	},
	{
		{
			0x9c, 0x84, 0x06, 
			0x62, 0xcb, 0x0e, 
			0x1d, 0xa6, 0x06, 
			0x20, 0x13, 0x0d, 
			0x2d, 0x5d, 0x04, 
			0x58, 0xa9, 0x07, 
			0xbe, 0xab, 0x0e, 
		},
		2, Stairs71,
		3, Monsters71,
		0, nullptr,
	},
	{
		{
			0x9c, 0x48, 0x04, 
			0xa2, 0xd7, 0x07, 
			0x2e, 0x2a, 0x07, 
			0x98, 0x13, 0x0e, 
			0x8e, 0x9e, 0x04, 
			0xa4, 0x55, 0x07, 
			0xaa, 0xbb, 0x0e, 
		},
		2, Stairs72,
		4, Monsters72,
		2, Knives72,
	},
	{
		{
			0x94, 0x84, 0x04, 
			0xa1, 0xe7, 0x05, 
			0x2d, 0x6a, 0x07, 
			0x98, 0x13, 0x0e, 
			0x1c, 0xae, 0x04, 
			0xb8, 0x6a, 0x0f, 
			0xae, 0xba, 0x0e, 
		},
		3, Stairs73,
		3, Monsters73,
		0, nullptr,
	},
	{
		{
			0xa8, 0x88, 0x06, 
			0x51, 0xe7, 0x0c, 
			0x1e, 0x6a, 0x07, 
			0x58, 0x22, 0x0e, 
			0x29, 0x9d, 0x04, 
			0x78, 0xa6, 0x0f, 
			0xba, 0xaa, 0x0e, 
		},
		0, nullptr,
		4, Monsters74,
		1, Knives74,
	},
};
const Stage[] Stages = {
	{
		2, Floors0,
		(0 << 4) | 0, // start
		(9 << 4) | 6, // goal
	},
	{
		2, Floors1,
		(9 << 4) | 6, // start
		(1 << 4) | 4, // goal
	},
	{
		3, Floors2,
		(0 << 4) | 6, // start
		(4 << 4) | 1, // goal
	},
	{
		3, Floors3,
		(0 << 4) | 6, // start
		(9 << 4) | 0, // goal
	},
	{
		4, Floors4,
		(0 << 4) | 0, // start
		(9 << 4) | 5, // goal
	},
	{
		4, Floors5,
		(9 << 4) | 5, // start
		(1 << 4) | 5, // goal
	},
	{
		5, Floors6,
		(0 << 4) | 0, // start
		(9 << 4) | 3, // goal
	},
	{
		5, Floors7,
		(4 << 4) | 6, // start
		(6 << 4) | 6, // goal
	},
};
